Flare Item Generator
--------------------

An extremely simple templater for [Flare RPG](https://flarerpg.org), no dependencies, works on Linux and Windows too.

Usage
-----

This is a command line tool, which expects 3 arguments: the first is a json file, the second is the starting id number, and
the last is the ending id number. For example:
```sh
$ ./flaregen loot.json 10 13 >items.txt
```

It prints the generated item definitions to stdout, which you can redirect to a file or append to your existing items.txt.

The JSON
--------

What kind of items should be generated is described in a JSON, each item field in one record. Normally you can reference
to the running counter in the item field's value, but you can also override that. There's a special field name, `INCLUDE`,
because the syntax is slightly different for that (no equals sign, there's a space instead).

| JSON field   | Description                                                             |
|--------------|-------------------------------------------------------------------------|
| `name`       | Mandatory. Specifies the item field's name                              |
| `value`      | Mandatory. Value mask. Use `%d` where you want the counter              |
| `add`        | Optional. Adds a numeric value to the running counter. Can be negative  |
| `min`, `max` | Optional. When given, replaces the running counter with a random number |

Examples:

```json
{
  { "name": "name", "value": "Item #%d", "add": 3 },
  { "name": "quality", "value": "normal" },
  { "name": "icon", "value": "%d", "add": 88 },
  { "name": "price", "value": "%d", "min": 100, "max": 500 },
  { "name": "soundfx", "value": "soundfx/inventory/inventory_coins.ogg" },
  { "name": "INCLUDE", "value": "items/categories/loot.txt" }
}
```
In this example we have a "name" field, with a value of "Item #" and a number. That number is the running counter (starting
from 1) plus three, so the first name will be "Item #4". The value in "add" could be negative as well.

The "quality", "soundfx", "INCLUDE" fields are constants. Create multiple templates for different item types, eg. one for
weapons, one for potions etc.

The "icon" is the running counter plus 88. One could use "min" and "max" to choose a random icon from a range.

The "price" has "min" and "max" description, so it will be a random number in that range.

That's all, have fun kids!

Cheers,
bzt
